// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <iostream>
#include <cstdio>
#include <cassert>

#include "globals.hh"
#include "Pingu.hh"
#include "Pingu.hh"
#include "CaptureRectangle.hh"

CL_Surface* CaptureRectangle::good; 
CL_Surface* CaptureRectangle::bad; 


CaptureRectangle::CaptureRectangle()
{

} 

CaptureRectangle::~CaptureRectangle()
{
}

void
CaptureRectangle::draw_offset(int x_offset, int y_offset, double s)
{ 
  CL_Surface* sur;
  
  if ( action->get_environment() & current_pingu->get_environment()) {
    sur = good;
  } else {
    sur = bad;
  }
  
  if (s == 1.0) {
    sur->put_screen(current_pingu->get_x()-17+x_offset, current_pingu->get_y()-33+y_offset);
  } else {
    sur->put_screen((int)((current_pingu->get_x()-17+x_offset) * s), 
		    (int)((current_pingu->get_y()-33+y_offset) * s),
		    (int)(sur->get_width() * s),
		    (int)(sur->get_height() * s)
		    );
  }
}


void 
CaptureRectangle::set_action(PinguAction* ac)
{
  action = ac;
}

void
CaptureRectangle::set_pingu(Pingu* pingu)
{
  current_pingu = pingu; 
}

void
CaptureRectangle::load_data()
{
  good = CL_Res_Surface::load("Game/capgood", *resource());
  bad  = CL_Res_Surface::load("Game/capbad",  *resource()); 
}  
/* EOF */

