// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef PLAYFIELD_HH
#define PLAYFIELD_HH

#include <ClanLib/clanlib.h>

#include "Range.hh"
#include "ButtonPanel.hh"
#include "GuiObj.hh"
#include "World.hh"
#include "GameObj.hh"
#include "CaptureRectangle.hh"
#include "View.hh"
#include "PinguInfo.hh"

class Playfield : public GuiObj, public GameObj
{
private:  
  //  CL_Streamed_MikModSample* wav;
  //  CL_SoundBuffer_Session* ses;
  int x_offset, y_offset;
  Range x_offset2, y_offset2;
  //  Result* result;
  int current_pingu;
  CL_Surface* buffer;
  static CL_Surface* pause_s;
  static AnimCounter pause_c;
  // static CL_Surface* cap;
  CaptureRectangle* cap; 
  CL_InputSourceProvider* datafile;
  vector<Pingu* >* pingu;
  ButtonPanel* buttons;
  bool mouse_scrolling;
  bool pause;
  World* world;
  vector<View> view;
  int current_view;
  PinguInfo* pingu_info;
public:
  Playfield();
  Playfield(PLF*, World*);
  ~Playfield();

  void draw();
  void let_move();
  void set_buttons(ButtonPanel* b);
  //  void write_results();
  void process_input();
  void set_world(World*);
  static void load_data();
  int current_pingu_find(int x, int y);
  bool enough_time_passed();
  void set_pingu_info(PinguInfo*);
};

#endif

/* EOF */
